import UIKit
import BMLTiOSLib

class ViewController : UIViewController, BMLTiOSLibDelegate {
    var _libraryInstance: BMLTiOSLib! = nil
    
    override func viewDidLoad() {
        super.viewDidLoad()
        
        // This is a string that points to a VALID Root Server instance
        // (>=10.2.8.1 running HTTPS, and with most of its data fields unmodified from default).
        let rootServerURI = "https://tkddevel.com/bmltwork/bmlt/main_server/"
        
        // Create an instance of the class. This immediately begins a communication process with the Root Server,
        // and the callbacks will be the next course of action.
        self._libraryInstance = BMLTiOSLib(inRootServerURI: rootServerURI, inDelegate: self)
    }
    
    // These are the required callback functions for the BMLTiOSLibDelegate class.
    
    // This is called upon successful connection and querying of the Root Server (or unsuccessful)
    func bmltLibInstance(_ inLibInstance: BMLTiOSLib, serverIsValid: Bool) {
        let alertController = UIAlertController(title: (serverIsValid ? "EXCELLENT!" : "BOGUS!"), message: "The initialization has completed.", preferredStyle: .alert)
        
        let okAction = UIAlertAction(title: "OK", style: UIAlertActionStyle.cancel, handler: nil)
        
        alertController.addAction(okAction)
        
        self.present(alertController, animated: true, completion: nil)
    }
    
    // This is called if the BMLTiOSLib suffers an error of some sort.
    func bmltLibInstance(_ inLibInstance: BMLTiOSLib, errorOccurred error: Error) {
        let alertController = UIAlertController(title: "ERROR!", message: "\(error)", preferredStyle: .alert)
        
        let okAction = UIAlertAction(title: "OK", style: UIAlertActionStyle.cancel, handler: nil)
        
        alertController.addAction(okAction)
        
        self.present(alertController, animated: true, completion: nil)
    }
}

